module axi4_lite_to_apb4_tb();

localparam AXI_ADDR_WIDTH = 32;
localparam AXI_DATA_WIDTH = 32;

logic i_clk;
logic i_rst;

logic i_AWVALID;
logic o_AWREADY;
logic [AXI_ADDR_WIDTH-1:0] i_AWADDR;
logic [2:0] i_AWPROT;

logic i_WVALID;
logic o_WREADY;
logic [AXI_DATA_WIDTH-1:0] i_WDATA;
logic [AXI_DATA_WIDTH/8-1:0] i_WSTRB;

logic o_BVALID;
logic i_BREADY;
logic [1:0] o_BRESP;

logic i_ARVALID;
logic o_ARREADY;
logic [AXI_ADDR_WIDTH-1:0] i_ARADDR;
logic [2:0] i_ARPROT;

logic o_RVALID;
logic i_RREADY;
logic [AXI_DATA_WIDTH-1:0] o_RDATA;
logic [1:0] o_RRESP;

logic m_apb_psel;
logic m_apb_penable;
logic m_apb_pwrite;
logic [2:0] m_apb_pprot;
logic [AXI_ADDR_WIDTH-1:0] m_apb_paddr;
logic [AXI_DATA_WIDTH-1:0] m_apb_pwdata;
logic [AXI_DATA_WIDTH/8-1:0] m_apb_pstrb;
logic  m_apb_pready;
logic  [AXI_DATA_WIDTH:0] m_apb_prdata;
logic  m_apb_pslverr;


initial begin
    i_clk <= '1;
    forever begin
        #10 i_clk = ~i_clk;
    end
end


// yes I used .*, sue me.
axi4_lite_to_apb4 dut(
    .*
);


initial begin
    $dumpfile("axi4_lite_to_apb4_tb.vcd");
    $dumpvars(0, axi4_lite_to_apb4_tb);
end

initial begin
    i_rst = '1;

    i_AWVALID = '0;
    i_AWADDR = '0;
    i_AWPROT = '0;

    i_WVALID = '0;
    i_WDATA = '0;
    i_WSTRB = '0;

    i_BREADY = '1;

    i_ARVALID = '0;
    i_ARADDR = '0;
    i_ARPROT = '0;

    i_RREADY = '1;

    m_apb_pready = '1;
    m_apb_prdata = '0;
    m_apb_pslverr = '0;


    repeat (5) @(posedge i_clk);
    i_rst = '0;
    repeat (5) @(posedge i_clk);


    i_ARVALID = '1;
    i_ARADDR = 32'haa5500ff;
    @(posedge i_clk);

    m_apb_prdata = 32'h5555aaaa;
    i_ARVALID = '0;
    i_ARADDR = '0;

    repeat (5) @(posedge i_clk);

    i_ARVALID = '1;
    i_ARADDR = 32'h88888888;
    @(posedge i_clk);

    m_apb_prdata = 32'h11111111;
    i_ARVALID = '0;
    i_ARADDR = '0;

    repeat (5) @(posedge i_clk);

    i_AWVALID = '1;
    i_AWADDR = 32'h22222222;
    i_WVALID = '1;
    i_WDATA = 32'h33333333;
    @(posedge i_clk);
    i_AWVALID = '0;
    i_AWADDR = '0;
    i_WVALID = '0;
    i_WDATA = '0;

    repeat (5) @(posedge i_clk);

    $finish();
end

endmodule