`timescale 1ns/1ps

module sync_fwft_fifo_tb();

logic clk;

initial begin
    clk <= '1;
    forever begin
        #1 clk <= ~clk;
    end
end

logic rst, w_en, r_en, o_full, o_empty;
logic [31:0] i_data, o_data;

sync_fwft_fifo #(
    .DEPTH(8),
    .WIDTH(32)
) u_sync_fifo (
    .i_rst(rst),
    .i_clk(clk),
    .w_en(w_en),
    .i_data(i_data),
    .o_full(o_full),
    .r_en(r_en),
    .o_data(o_data),
    .o_empty(o_empty)
);

task write(input [31:0] data);
    i_data <= data;
    w_en <= '1;
    @(posedge clk);
    w_en <= '0;
endtask

task read(output [31:0] data);
    r_en <= '1;
    @(posedge clk);
    r_en <= '0;
    data <= o_data;
endtask

logic [31:0] rd_data;

initial begin
    rst <= 1;
    r_en <= 0;
    w_en <= 0;
    repeat (5) @(posedge clk);
    rst <= 0;
    @(posedge clk)

    for (int i = 1; i < 12; i++) begin
        write(i);
    end

    for (int i = 1; i < 12; i++) begin
        read(rd_data);
    end

    for (int i = 1; i < 12; i++) begin
        write(i);
    end

    for (int i = 1; i < 12; i++) begin
        read(rd_data);
    end

    rst <= 1;
    repeat (5) @(posedge clk);
    rst <= 0;
    @(posedge clk);

    write(0);
    for (int i = 1; i < 50; i++) begin
        write(i);
        read(rd_data);
    end
    read(rd_data);

    repeat (5) @(posedge clk);

    $finish();
end

initial begin
    $dumpfile("sync_fwft_fifo_tb.vcd");
    $dumpvars(0,sync_fwft_fifo_tb);
end

endmodule
