interface axi4_lite_if #(
    ADDR_WIDTH = 32,
    DATA_WIDTH = 32
);

logic                       AWVALID;
logic                       AWREADY;
logic [ADDR_WIDTH-1:0]      AWADDR;
logic                       WVALID;
logic                       WREADY;
logic [DATA_WIDTH-1:0]      WDATA;
logic [DATA_WIDTH/8-1:0]    WSTRB;
logic                       BVALID;
logic                       BREADY;
logic [1:0]                 BRESP;
logic                       ARVALID;
logic                       ARREADY;
logic [ADDR_WIDTH-1:0]      ARADDR;
logic                       RVALID;
logic                       RREADY;
logic [DATA_WIDTH-1:0]      RDATA;
logic [1:0]                 RRESP;

modport slave (
    input   AWVALID,
    output  AWREADY,
    input   AWADDR,

    input   WVALID,
    output  WREADY,
    input   WDATA,
    input   WSTRB,

    output  BVALID,
    input   BREADY,
    output  BRESP,

    input   ARVALID,
    output  ARREADY,
    input   ARADDR,

    output  RVALID,
    input   RREADY,
    output  RDATA,
    output  RRESP
);

modport master (
    output  AWVALID,
    input   AWREADY,
    output  AWADDR,

    output  WVALID,
    input   WREADY,
    output  WDATA,
    output  WSTRB,

    input   BVALID,
    output  BREADY,
    input   BRESP,

    output  ARVALID,
    input   ARREADY,
    output  ARADDR,

    input   RVALID,
    output  RREADY,
    input   RDATA,
    input   RRESP
);

endinterface