module endian_flip #(
    parameter ENABLE = 0,
    parameter SIZE = 8,
    parameter GROUPS = 4
)(
    input [SIZE*GROUPS-1:0] i_data,
    output logic [SIZE*GROUPS-1:0] o_data
);

always_comb begin
    for (int i = 0; i < GROUPS; i++) begin
        o_data[SIZE*i+:SIZE] = i_data[SIZE*(GROUPS-1-i)+:SIZE];
    end
end


endmodule