// Copyright (c) 2023 Byron Lathi

module ff_cdc #(
    parameter WIDTH=1,
    parameter STAGES=2,
    parameter RESET_VAL=0
)(
    input [WIDTH-1:0] data_a,

    input clk,
    input rst,
    output logic [WIDTH-1:0] data_b
);

logic [WIDTH-1:0] stage1, stage2, stage3;

always @(posedge clk or posedge rst) begin
    if (rst) begin
        stage1 <= RESET_VAL;
        stage2 <= RESET_VAL;
        stage3 <= RESET_VAL;
    end else begin
        stage1 <= data_a;
        stage2 <= stage1;
        stage3 <= stage2;
    end
end

always_comb begin
    if (STAGES == 2) begin
        data_b = stage2;
    end

    if (STAGES == 3) begin
        data_b = stage3;
    end
end

endmodule